Package org.apache.lucene.index

## Class StoredFields

- java.lang.Object
- - org.apache.lucene.index.StoredFields

- Direct Known Subclasses:
    `StoredFieldsReader`

      public abstract class StoredFields
      extends Object

  API for reading stored fields.

  NOTE: This class is not thread-safe and should only be consumed in the thread where it was acquired.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `StoredFields()` | Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Document` | `document​(int docID)` | Returns the stored fields of the `n`th `Document` in this index.
    `Document` | `document​(int docID, Set<String> fieldsToLoad)` | Like `document(int)` but only loads the specified fields.
    `abstract void` | `document​(int docID, StoredFieldVisitor visitor)` | Expert: visits the fields of a stored document, for custom processing/loading of each field.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StoredFields

          protected StoredFields()

      Sole constructor. (For invocation by subclass constructors, typically implicit.)

  - ### Method Detail

    - #### document

          public final Document document​(int docID)
                                  throws IOException

      Returns the stored fields of the `n`th `Document` in this index. This is just sugar for using `DocumentStoredFieldVisitor`.

      NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can test if the doc is deleted by checking the `Bits` returned from `MultiBits.getLiveDocs(org.apache.lucene.index.IndexReader)`.

      NOTE: only the content of a field is returned, if that field was stored during indexing. Metadata like boost, omitNorm, IndexOptions, tokenized, etc., are not preserved.

      Throws:
        `CorruptIndexException` - if the index is corrupt
        `IOException` - if there is a low-level IO error

    - #### document

          public abstract void document​(int docID,
                                        StoredFieldVisitor visitor)
                                 throws IOException

      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Throws:
        `IOException`

    - #### document

          public final Document document​(int docID,
                                         Set<String> fieldsToLoad)
                                  throws IOException

      Like `document(int)` but only loads the specified fields. Note that this is simply sugar for `DocumentStoredFieldVisitor(Set)`.
      Throws:
        `IOException`